"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const DefaultRegistry = require("undertaker-registry");
const asyncDone = require("async-done");
const core_decorators_1 = require("core-decorators");
const taskContext_1 = require("./taskContext");
const taskTracker_1 = require("./taskTracker");
let Registry = class Registry extends DefaultRegistry {
    constructor(config) {
        super();
        assert(typeof config.rootPath === 'string', 'rootPath must be defined in Registry options');
        this.context = new taskContext_1.TaskContext(config);
    }
    init(gulp) {
        super.init(gulp);
        /* tslint:disable-next-line */
        const tracker = new taskTracker_1.TaskTracker(gulp);
    }
    // lazily load task dependencies so overridden task definitions are injected as part of these chains
    inject(taskname) {
        const fn = done => asyncDone(this.get(taskname), done);
        fn.displayName = `[injected] ${taskname}`;
        return fn;
    }
};
Registry = __decorate([
    core_decorators_1.autobind
], Registry);
exports.Registry = Registry;
